Program
	HTMLView;

{
	HTML02 Successfully loads & pre-parses HTML (text and tags)
	HTML03 Pre-parse 2 works (text, tags and their parameters)
	HTML04 Implementing main parser... preliminary success!
	HTML05 Implementing tag stack...

	28.08
		Implementing tag stack... OK!
	30.08
		Fixer <BR><BR> bug
	02.09
		Implementing tables... seems like OK!
	06.09
		Implementing structure (TITLE, BODY with params).. OK
		Implementing spec. chars translation (&nbsp; etc).. OK
	07.09
		Implemented table frames, CELLSPACING, BORDER
		Fixed bug with columns number
		Work with doc sections is now more correct and simple
	09.09
		Fake IMG support
		More correct line height handling (CurLineHeigth -> ThisTextHeight)
		Implementing alignments... <CENTER>, <P ALIGN=Left/Center/Right> OK!!!
	13.09
		Implementing table CELLPADDING... OK!
		Implementing BGCOLOR... OK! (well, kind of :)
	14.09
		Preparing to port to Polit
		1. Using linked lists...
		SrcLines: OK
	16.09
		Chunks... OK
	18.09
		Chunk params... OK
		todo: use placeholder for table bgcolor bar.. OK
	19.09
		using orig D, Types units
		PageItems... 14:59 OK!
		tuning TChunk.. TPageItem.. OK (string -> pstr)
		freeing structures: src lines.. chunks..
		TableStack^
	21.09
		correcting <TD BGCOLOR> (process in </TR>)... OK!
		drawing a cool CHR font...
	22.09
		CHR font is (almost) cool!
		Developing own VFont unit...
		21:00 DrawChar works! With scaling!
		Yeah! Gfx.QualityLine works!!! Using it in VFont.. much better!
		Yeah! Print() works! Speed optimizations can wait :)
		Porting HTML engine to GFX+VFont...
	23.09
		OK, even with antialias!!!
	25.09
		Implementing font attributes.. Bold.. Underline.. Italic!!!
		Normal color support (RGB / named / legacy indexes)!
	26.09
		Now I'll try to solve the soft spaces problem forever..... half-works
	28.09
		Spaces problem seems to be fixed?..
		Trying to speed up bold chars drawing... failure
		Implementing vertical (baseline) alignment... yeah, BigBug(tm) fixed!
			(I had to check PageItem kind before taking its Attr.Size)
	09.10
		Loading pictures...
	16.11
		Testing on animex1.htm... works! (kind of :)
		Trying to fix leading & tailing spaces problem... seems to work!!
		Figuring out what's up with CellPadding and why it doesn't work...
		Found a bug (writes out of array bounds in TagTABLE filling Col[])
	22.11
		Workarounded a bug with table alignment when width is unspecified










}

Uses
	GFX, VFont, D, Types, Pic;

{Const
	MaxSrcLines=100;
	MaxChunks=100;
	MaxPageItems=90;}

Type
	TChunkKind=(chTag, chText);
	String18=String[18];
	PParam=^TParam;
	TParam=Record
		Name: String18;
		Value: PStr;
		Next: PParam;
	End;
	PChunk=^TChunk;
	TChunk=Record
		Next: PChunk;
		Case Kind: TChunkKind Of
			chTag: (
				Tag: String18;
				Opening: Boolean;
				FirstParam: PParam;
				SoftSpaces: Set Of (ssLeading, ssTailing);
			);
			chText: (Text: PStr);
	End;

	TPageItemKind=(piText, piLink, piImage, piRect, piBar,
		piPlaceholder);
	TTextAttr=Record
		Size, Color, Face: Integer;
		Attr: TFontAttr;
		Align: TAlign;
	End;
	PPageItem=^TPageItem;
	TPageItem=Record
		Kind: TPageItemKind;
		Place: TRect;
		Text: PStr; { text, link text, image path }
		Attr: TTextAttr;
		Href: PStr; { link target, image link target }
		Image: Pointer;
		Color1, Color2: TColor;
		Prev, Next: PPageItem;
	End;

	TDocProperties=Record
		BGColor: Integer;
		TextColor: Integer;
		LinkColor: Integer;
		Title: String;
	End;
	TBGKind=(bgNone, bgColor, bgImage);


Var
	(*Src: Array[1..MaxSrcLines] Of String[100];     { to remove }
	SrcNum: Integer;                                 { to remove } *)

	FirstSrcLine, LastSrcLine: PPtrList;

	(*Chunk: Array[1..MaxChunks] Of TChunk;          { to remove }
	ChunkNum: Integer;                               { to remove } *)

	FirstChunk, LastChunk: PChunk;

	(*PageItem: Array[1..MaxPageItems] Of TPageItem; { to remove }
	PageItemNum, LastPlaceholderIndex: Integer;      { to remove }*)

	FirstPageItem, LastPageItem, LastPlaceholderItem: PPageItem;



	Area: Array[1..40] Of TRect;
	AreaNum: Integer;

	DocProps: TDocProperties;

	OrigMem: LongInt;
	MyFont: Pointer;



Procedure InitGraphics;
Var
	F: File;
Begin
	Log.Init('html.log', True);
	Assign(F, 'dflt.chr');
	Reset(F, 1);
	GetMem(MyFont, FileSize(F));
	BlockRead(F, MyFont^, FileSize(F));
	Close(F);
	VFont.SetFont(MyFont);

	Gfx.SetMode(1024, 768, 8);
	Gfx.MakeRGB2Pal;
End;


{$I Htm_Load.Inc}

{$I Htm_PreP.Inc}

{$I Htm_Pars.Inc}

{$I Htm_Draw.Inc}

{ ******* MAIN PROGRAM ******* }

Begin
	InitGraphics;
	OrigMem:=MemAvail;
	LoadHTML;
	BreakToChunks;
	ParseChunks;
	DrawPage;
	ReadLn;

	FreePageItems;
	FreeChunks;
	FreeSrcLines;
	Gfx.SavePCX(0, 0, 639, 479, 'lastshot.pcx');
	Log.Done;
	{Gfx.Done;
	WriteLn('MemAvail before: ', D.NormNum(D.StL(OrigMem)):9);
	WriteLn('MemAvail after:  ', D.NormNum(D.StL(MemAvail)):9);
	WriteLn('Leaked memory:   ', D.NormNum(D.StL(OrigMem-MemAvail)):9);
	ReadLn}
End.