Unit
	LPT;

Interface

Uses
	DOS, Ini;

Var
	Port: Word;

	Procedure SendChar(C:Char);
	Procedure Init;
	Function GetState: Byte;
	Function Ready: Boolean;
   Function ReadyExceptBusy: Boolean;

Implementation

Var
	R: Registers;

Procedure SendChar(C:Char);
Begin
	R.AH:=0;
	R.AL:=Byte(C);
	R.DX:=Port;
	Intr($17, R)
End;

Procedure Init;
Begin
	R.AH:=1;
	R.DX:=Port;
	Intr($17, R)
End;

Function GetState: Byte;
Begin
	R.AH:=2;
	R.DX:=Port;
	Intr($17, R);
	GetState:=R.AH
End;

Function Ready: Boolean;
Var
	B: Byte;
Begin
	B:=GetState;
	{Ready:=((B And $80)<>0) And ((B And $20)=0)}
	Ready:=((B And 128)=128) And ((B And 32)=0) And ((B And 8)=0) And ((B And 1)=0)
End;

Function ReadyExceptBusy: Boolean;
Var
	B: Byte;
Begin
	B:=GetState;
	ReadyExceptBusy:=((B And 32)=0) And ((B And 8)=0) And ((B And 1)=0)
End;


Begin
	Port:=0; { LPT1 by default }
	(*Ini.Select('polit.ini', 'Print');
	Port:=0; { LPT1 by default }
	If Ini.GetStr('Port', 'LPT1')='LPT2' Then Port:=1;
	If Ini.GetStr('Port', 'LPT1')='LPT3' Then Port:=2*)
End.