{$F+}
Unit
	TestChk; { Polit Halcyon TestChk application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2;

Type
	TTestChkData=Record
		{ i i ணࠬ  ,  쮬 i }
		ChkAlpha, ChkBeta, ChkGamma, LabState: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestChkData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Ctl.Check_Paint(ChkAlpha, 10, 10);
		Ctl.Check_Paint(ChkBeta, 10, 30);
		Ctl.Check_Paint(ChkGamma, 10, 50);
		Ctl.Label_Paint(LabState, 10, 80, X2-X1-10);
	End;
End;

Procedure OnCheckChange(Me:PProg; Control:PControl);
Var
	TempStr: String;
Begin
	With Me^, TTestChkData(Data^) Do
	Begin
		TempStr:='';
		If Ctl.Check_GetState(ChkAlpha) Then
			TempStr:=TempStr+'Alpha ';
		If Ctl.Check_GetState(ChkBeta) Then
			TempStr:=TempStr+'Beta ';
		If Ctl.Check_GetState(ChkGamma) Then
			TempStr:=TempStr+'Gamma ';
		Ctl.Label_SetCaption(LabState, TempStr)
	End
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestChkData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=240;
		MinY:=140;
		GetMem(Data, SizeOf(TTestChkData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestChkData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			ChkAlpha:=Ctl.Check_Create(Me, 'Alpha', False);
			ChkBeta:=Ctl.Check_Create(Me, 'Beta', False);
			ChkGamma:=Ctl.Check_Create(Me, 'Gamma', False);
			LabState:=Ctl.Label_Create(Me, '', Nil, lsBeveled, alCenter);

			Ctl.Check_SetOnChange(ChkAlpha, OnCheckChange);
			Ctl.Check_SetOnChange(ChkBeta, OnCheckChange);
			Ctl.Check_SetOnChange(ChkGamma, OnCheckChange);

		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestChk', 'TestChk', 'pic\i_app.bmp', OnInit)
End.
