{$F+}
Unit
	TestHTM1; { Polit Halcyon TestHTM1 application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Ctl3, Popup;

Type
	TTestHTM1Data=Record
		HtmTest: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestHTM1Data(Data^) Do
	Begin
		Ctl3.HTML_Paint(HtmTest, 5, 5, X2-X1-5, Y2-Y1-5);
	End;
End;

Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TTestHTM1Data))
End;

Procedure OnInit(Me:PProg);
Var
	FName: String;
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		FName:=String(Param^);
		If Not D.FileExist(FName) Then FName:='test6.htm';
		D.AssignPStr(D.LastPathItem(FName), WinTitle);

		D.AssignPStr(' HTML', WinTitle);
		MinX:=350;
		MinY:=240;
		GetMem(Data, SizeOf(TTestHTM1Data));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestHTM1Data(Data^) Do
		Begin
			HtmTest:=Ctl3.HTML_Create(Me);
			Ctl3.HTML_LoadFile(HtmTest, FName);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestHTM1', 'TestHTM1', 'pic\i_app.bmp', OnInit)
End.
