{$F+}
Unit
	TestNbk; { Polit Halcyon TestNbk application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Popup;

Type
	TTestNbkData=Record
		{ i i ணࠬ  ,  쮬 i }
		NbkPages: PControl;
		LabWelcome: PControl;
		ChkTruth: PControl;
		ProIndet: PControl;
		BtnClose: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestNbkData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Kernel.DarkBar(X1, Y1, X2, Y1+4);
		Kernel.DarkBar(X1, Y1+5, X1+4, Y2-30);
		Kernel.DarkBar(X2-4, Y1+5, X2, Y2-30);
		Kernel.DarkBar(X1, Y2-29, X2, Y2);
		Kernel.WindowBar(X1+5, Y1+5, X2-5, Y2-30, False, False);

		Ctl.Notebook_Paint(NbkPages, 5, 5, X2-X1-5, Y2-Y1-30);
		Ctl.Label_Paint(LabWelcome, 15, 35, X2-X1-15);
		Ctl.Check_Paint(ChkTruth, 15, 35);
		Ctl.Progress_Paint(ProIndet, 15, 35, X2-X1-15);
		Ctl.Button_Paint(BtnClose, X2-X1-90, Y2-Y1-25, X2-X1-5);
	End;
End;


Procedure OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestNbkData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=150;
		MinY:=90;
		GetMem(Data, SizeOf(TTestNbkData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		WinBG:=bgManualDark;
		Kernel.DrawWindowAni(Me);

		With TTestNbkData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			NbkPages:=Ctl.Notebook_Create(Me, True);
			LabWelcome:=Ctl.Label_Create(Me,
				'Welcome to the real world!', Nil,
				lsComment, alCenter);
			Ctl.Notebook_AddPage(NbkPages, '', 'Neo', Nil);
			ChkTruth:=Ctl.Check_Create(Me,
				'  ࠢ?', True);
			Ctl.Notebook_AddPage(NbkPages, '䥩', 'Morpheus', Nil);
			ProIndet:=Ctl.Progress_Create(Me, 1, 5, 1, pkIndeterm);
			Ctl.Notebook_AddPage(NbkPages, 'iii', 'Trinity', Nil);
			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, OnCloseClick);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestNbk', 'TestNbk', 'pic\i_app.bmp', OnInit)
End.
