{$F+}
Unit
	TestRad; { Polit Halcyon TestRad application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2;

Type
	TTestRadData=Record
		{ i i ணࠬ  ,  쮬 i }
		RadQ, RadK, RadA: PControl;
		Rad1, Rad2, Rad3, Rad4: PControl;
		LabState: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestRadData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Ctl.Radio_Paint(RadQ, 10, 10);
		Ctl.Radio_Paint(RadK, 10, 30);
		Ctl.Radio_Paint(RadA, 10, 50);
		Ctl.Radio_Paint(Rad1, 120, 10);
		Ctl.Radio_Paint(Rad2, 120, 30);
		Ctl.Radio_Paint(Rad3, 120, 50);
		Ctl.Radio_Paint(Rad4, 120, 70);
		Ctl.Label_Paint(LabState, 10, 100, X2-X1-10);
	End;
End;

Procedure OnRadioChange(Me:PProg; Control:PControl);
Var
	TempStr: String;
Begin
	With Me^, TTestRadData(Data^) Do
	Begin
		If Radio_Selected(RadQ) Then TempStr:='';
		If Radio_Selected(RadK) Then TempStr:='஫';
		If Radio_Selected(RadA) Then TempStr:='';
		TempStr:=TempStr+', ';
		If Radio_Selected(Rad1) Then TempStr:=TempStr+'ࢠ';
		If Radio_Selected(Rad2) Then TempStr:=TempStr+'㡭';
		If Radio_Selected(Rad3) Then TempStr:=TempStr+'i';
		If Radio_Selected(Rad4) Then TempStr:=TempStr+'';
		Ctl.Label_SetCaption(LabState, TempStr)
	End
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestRadData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=240;
		MinY:=130;
		GetMem(Data, SizeOf(TTestRadData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestRadData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			RadQ:=Ctl.Radio_Create(Me, '', True, 1);
			RadK:=Ctl.Radio_Create(Me, '஫', False, 1);
			RadA:=Ctl.Radio_Create(Me, '', False, 1);
			Rad1:=Ctl.Radio_Create(Me, 'ࢠ', True, 2);
			Rad2:=Ctl.Radio_Create(Me, '㡭', False, 2);
			Rad3:=Ctl.Radio_Create(Me, 'i', False, 2);
			Rad4:=Ctl.Radio_Create(Me, '', False, 2);
			LabState:=Ctl.Label_Create(Me, ', ࢠ', Nil,
				lsBeveled, alCenter);

			Ctl.Radio_SetOnChange(RadQ, OnRadioChange);
			Ctl.Radio_SetOnChange(RadK, OnRadioChange);
			Ctl.Radio_SetOnChange(RadA, OnRadioChange);
			Ctl.Radio_SetOnChange(Rad1, OnRadioChange);
			Ctl.Radio_SetOnChange(Rad2, OnRadioChange);
			Ctl.Radio_SetOnChange(Rad3, OnRadioChange);
			Ctl.Radio_SetOnChange(Rad4, OnRadioChange);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestRad', 'TestRad', 'pic\i_app.bmp', OnInit)
End.
