{$F+}
Unit
	TestTim; { Polit Halcyon TestTim application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Popup;

Type
	TTestTimData=Record
		{ i i ணࠬ  ,  쮬 i }
		LabClock, BtnStop, TimTicker: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestTimData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Ctl.Label_Paint(LabClock, 10, 10, X2-X1-10);
		Ctl.Button_Paint(BtnStop, 10, 40, X2-X1-10);
	End;
End;


Procedure OnTimerTick(Me:PProg;
	Control:PControl; Times:Integer);
Var
	H, M, S, C: Word;
	TempStr: String;
Begin
	With Me^, TTestTimData(Me^.Data^) Do
	Begin
		DOS.GetTime(H, M, S, C);
		TempStr:=D.St2(H)+':'+D.St2(M)+'.'+D.St2(S);
		Ctl.Label_SetCaption(LabClock, TempStr)
	End
End;

Procedure OnStopClick(Me:PProg; Control:PControl);
Var
	StopPressed: Boolean;
Begin
	With Me^, TTestTimData(Data^) Do
	Begin
		StopPressed:=Ctl.Button_GetDown(BtnStop);
		Ctl.TimerCtl_SetActive(TimTicker, StopPressed);
		Ctl.Button_SetDown(BtnStop, Not StopPressed)
	End
End;


Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestTimData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=140;
		MinY:=70;
		GetMem(Data, SizeOf(TTestTimData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestTimData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			LabClock:=Ctl.Label_Create(Me, '', Nil, lsBeveled,
				alCenter);
			BtnStop:=Ctl.Button_Create(Me, '㯨 ',
				Nil, ppLeft, OnStopClick);
			TimTicker:=Ctl.TimerCtl_Create(Me, 18, True, OnTimerTick);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestTim', 'TestTim', 'pic\i_app.bmp', OnInit)
End.
