{ ************ Timer control ************ }
Type
	TTimerCtl=Record
		OnTimer:TTimerCtlProc;
		Active:Boolean
	End;

Procedure TimerCtl_Timer(Me:PControl; Times:Integer);
Begin
	With Me^,TTimerCtl(Data^) Do
		If Active Then
			OnTimer(Owner,Me,Times)
End;

Procedure TimerCtl_SetActive(Me:PControl; VActive:Boolean);
Begin
	With Me^,TTimerCtl(Data^) Do
		Active:=VActive
End;

Procedure TimerCtl_OnDestroy(Me:PControl);
Begin
	Kernel.RemoveTimer(Me,TimerCtl_Timer);
	FreeMem(Me^.Data, SizeOf(TTimerCtl))
End;

Function TimerCtl_Create(Prog:PProg;Freq:Integer;VActive:Boolean;
	VOnTimer:TTimerCtlProc):PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Kernel.CtlClickDummy,Kernel.CtlKeyDummy,
		Kernel.CtlRefocusDummy,Kernel.CtlDummy,TimerCtl_Destroy,
		False,False,'Timer');}
	With Me^ Do
	Begin
		OnDestroy:=TimerCtl_OnDestroy;
		Enabled:=False;
		D.AssignRect(-1, -1, -1, -1, Place);

		GetMem(Data,SizeOf(TTimerCtl));
		With TTimerCtl(Data^) Do
		Begin
			Active:=VActive;
			OnTimer:=VOnTimer
		End
	End;
	Kernel.AddTimer(Me,TimerCtl_Timer,Freq);
	TimerCtl_Create:=Me
End;
