{ ************ Button ************ }
Type
	TPicBtnMark=Array[Boolean] Of Pointer;
	TButton=Record
		Caption: PStr; 		{ }
		OnPress: TCtlHandler; 	{⨥}
		Down, DownNow: Boolean; {䫠 ,   ᥩ}
		Picture: Pointer; 	{⨭}
		PicturePos: TPicturePos;	{ ⨭}
		MarkStyle: TButtonMarkStyle;	{}
		PicMark: TPicBtnMark;		{}
		OwnerCtl: PControl;		{ }
	End;

Var
	ButtonInside: Boolean;
	PicBtnArDown, PicBtnArUp, PicBtnArRight, PicBtnDlg: TPicBtnMark;

Function Button_OnKey(Me:PControl; Key, ExtKey:Char):Boolean; {ᮡ⨥  ⮩ }
Begin {砫 㭪樨}
	With Me^, TButton(Data^) Do
		If Key=' ' Then
		Begin
			DownNow:=True; 		{㥬  }
			Button_Draw(Me);
				{ 2fix: delay }
			Kernel.WaitTicks(2);	{㧠  2 ⨪}
			DownNow:=False;		{㥬  }
			Button_Draw(Me);
			CurCtl:=Me;		{⠭ ⨢ 쥪}
			With TButton(Me^.Data^) Do
				If OwnerCtl=Nil
					Then OnPress(Me^.Owner, Me)
					Else OnPress(Me^.Owner, OwnerCtl);
			Button_OnKey:=True
		End
		Else
			Button_OnKey:=False
End;

Procedure Button_OnDestroy(Me:PControl); { ࠧ襭  (㤠)}
Begin
	With Me^, TButton(Data^) Do
	Begin
		D.FreePStr(Caption, 'Ctl - Button_OnDestroy');
		FreeMem(Data, SizeOf(TButton)) { ᢮   쥪  }
	End
End;

Procedure Button_Draw(Me:PControl);   {ᮢ }
Var {梥 ,,,, ⥪}
	ColorLU, ColorRD, ColorFill, ColorFont: TColor; 
	Indent, PicWidth, ContWidth: Integer;	{}
	TempStr: String; 			{६ ப ६}

	Procedure SetVals(A, B, C:TColor); 	{⠭ 梥⮢}
	Begin
		ColorLU:=A;
		ColorRD:=B;
		ColorFill:=C
	End;
Begin {᫨  ᮢ  ୥  쥪  ⮣ 室}
	If ((Not Me^.CanDraw) And (Not Kernel.DontBother)) Or Not Me^.Visible Then
		Exit;

	With Me^, TButton(Data^), Place Do
	Begin
		If Me=Owner^.ButtonEnter
			Then SetVals(clWhite, clNavy, clBlueGray)
			Else SetVals(clWhite, clGray, clSilver);

		If Down Or DownNow Then	{᫨   塞  ᮮ⢥騥 梥}
		Begin
			Indent:=4;
			SetVals(clNavy, clWhite, clBlueGray)
		End
		Else
			Indent:=3;
		If (Picture<>Nil) And (PicturePos=ppLeft)
			Then PicWidth:=Gfx.ImageX(Picture)+4 
			Else PicWidth:=0;

		Font.SetFont(Kernel.CurFont); {⠭ 䮭}
		If MarkStyle=bmNone		{     }
			Then TempStr:=Kernel.ShortenStr(String(Caption^),
				X2-X1-4-PicWidth)
			Else TempStr:=Kernel.ShortenStr(String(Caption^),
				X2-X1-4-PicWidth-Gfx.ImageX(PicMark[Enabled])-4);
		If Enabled Then
		Begin	{  }
			Gfx.FillButtonRect(X1, Y1, X2, Y2, ColorLU, ColorRD, ColorFill);
			If Me=Owner^.ButtonEsc Then
			Begin
				PutPixel(X1+1, Y1+1, clRed);
				PutPixel(X2-1, Y1+1, clRed);
				PutPixel(X1+1, Y2-1, clRed);
				PutPixel(X2-1, Y2-1, clRed)
			End; { ᫨ ⨭ ᫥ }
			If PicturePos=ppLeft Then
			Begin
				Font.Print(X1+PicWidth+Indent, Y1+Indent, clBlack, TempStr);
				If Picture<>Nil Then
					Gfx.PutSprite(X1+Indent, Y1+Indent-1, Picture);
				{If ComboArrow Then
					Gfx.PutSprite(X2-17+Indent, Y1+4+Indent, PicComboArrow)}
			End
			Else Begin { ppTop , ᫨ ᢥ}
				If MarkStyle=bmNone
					Then ContWidth:=X2-X1-3
					Else ContWidth:=X2-X1-3-Gfx.ImageX(PicMark[Enabled])-4;
				Font.Print(X1+Indent+(ContWidth-Font.Width(TempStr)) Div 2, Y2-19+Indent, clBlack, TempStr);
				If Picture<>Nil Then
					Gfx.PutSprite(X1+Indent+(ContWidth-Gfx.ImageX(Picture)) Div 2,
						Y1+Indent, Picture);
				{If ComboArrow Then
					Gfx.PutSprite(X2-17+Indent, (Y1+Y2-12) Div 2+Indent, PicComboArrow)}
			End
		End
		Else Begin 
			Gfx.FillButtonRect(X1, Y1, X2, Y2, clGray, clGray, clSilver);
			If PicturePos=ppLeft Then
			Begin
				Font.Print(X1+PicWidth+3, Y1+3, clGray, TempStr);
				If Picture<>Nil Then
					Gfx.PutSpriteGrayed16(X1+Indent, Y1+Indent-1, Picture);
				{If ComboArrow Then
					Gfx.PutSprite(X2-14, Y1+7, PicComboArrow0)}
			End
			Else Begin { ppTop }
				If MarkStyle=bmNone
					Then ContWidth:=X2-X1-3
					Else ContWidth:=X2-X1-3-Gfx.ImageX(PicMark[Enabled])-4;
				Font.Print(X1+Indent+(ContWidth-Font.Width(TempStr)) Div 2, Y2-19+Indent, clGray, TempStr);
				If Picture<>Nil Then
					Gfx.PutSpriteGrayed16(X1+Indent+(ContWidth-Gfx.ImageX(Picture)) Div 2,
						Y1+Indent, Picture);
				{If ComboArrow Then
					Gfx.PutSprite(X2-17+Indent, (Y1+Y2-12) Div 2+Indent, PicComboArrow0)}
			End
		End;
		If MarkStyle<>bmNone Then
			Gfx.PutSprite(X2-Gfx.ImageX(PicMark[Enabled])-7+Indent,
				Y1+(Y2-Y1-Gfx.ImageY(PicMark[Enabled])) Div 2-3+Indent,
				PicMark[Enabled])
	End;
End;

Procedure Button_Paint(Me:PControl; VX1, VY1, VX2:Integer); {ᮢ }
Begin
	With Me^, TButton(Data^), Owner^.ClientRect Do
		If (PicturePos=ppTop) And (Picture<>Nil)
			Then D.AssignRect(X1+VX1, Y1+VY1, X1+VX2,
				Y1+VY1+21+Gfx.ImageY(Picture), Me^.Place)
			Else D.AssignRect(X1+VX1, Y1+VY1, X1+VX2, Y1+VY1+20, Me^.Place);
	Button_Draw(Me) {ᮡ⢥ ᮢ}
End;

Procedure Button_HideMouse(Var X,Y:Integer);
Begin
	ButtonInside:=D.InRect(X, Y, CurCtl^.Place);
	Kernel.HideMouse(X, Y)
End;

Procedure Button_ShowMouse(Var X,Y:Integer);
Var
	InsideNow:Boolean;
Begin
	InsideNow:=D.InRect(X, Y, CurCtl^.Place);
	If ButtonInside Xor InsideNow Then
	Begin
		TButton(CurCtl^.Data^).DownNow:=InsideNow;
		Button_Draw(CurCtl)
	End;
	Kernel.ShowMouse(X, Y)
End;

Procedure Button_OnClick(Me:PControl; X, Y:Integer); {   }
Begin
	With TButton(Me^.Data^) Do
	Begin
		ButtonInside:=True;
		CurCtl:=Me;
		If Not Down Then { ᫨     }
			DownNow:=True;
		Button_Draw(Me); {ᮢ}
		Repeat
			Kernel.CheckSysKeys {  ஢ }
		Until Kernel.HeartOfPolit(Button_HideMouse, Button_ShowMouse,
			Kernel.RefreshNeeded)=0;
		If Not Down Then { ᫨      }
			DownNow:=False;
		Button_Draw(Me); ᮢ
		If D.InRect(Kernel.MsX, Kernel.MsY, Me^.Place) Then
			With Me^, TButton(Data^) Do
				If OwnerCtl=Nil
					Then OnPress(Me^.Owner, Me)
					Else OnPress(Me^.Owner, OwnerCtl)
	End
End;

Procedure Button_TryAutoRedraw(Me:PControl); {஡뢠 ⮬᪮ ᮢ}
Begin
	If Me^.AutoRedraw And Not Kernel.IgnoreAutoRedraw Then
		If (Me^.CanDraw Or Kernel.DontBother) And Me^.Visible Then
		Begin
			Kernel.BeginPaint(Me^.Place); {  祣 ᮢ }
			Button_Draw(Me); { ᮢ}
			Kernel.EndPaint {४ ᮢ}
		End
End;

Procedure Button_SetCaption(Me:PControl; VCaption:String); {⠭  }
Begin
	With Me^,TButton(Data^) Do
		D.ReAssignPStr(VCaption, Caption);
	Button_TryAutoRedraw(Me) {஡뢠 ᮢ뢠 ᠬ}
End;

Function Button_GetCaption(Me:PControl): String; { }
Begin
	With Me^,TButton(Data^) Do
		Button_GetCaption:=String(Caption^)
End;


Procedure Button_SetPicture(Me:PControl; VPicture:Pointer); {⠭ ⨪}
Begin
	With Me^,TButton(Data^) Do
		Picture:=VPicture;
	Button_TryAutoRedraw(Me)
End;

Procedure Button_SetDown(Me:PControl; VDown:Boolean);
Begin
	With Me^, TButton(Data^) Do
		Down:=VDown;
	Button_TryAutoRedraw(Me)
End;

Procedure Button_SetMarkStyle(Me:PControl; VMarkStyle:TButtonMarkStyle); { ⨯  }
Begin
	With Me^, TButton(Data^) Do
	Begin
		MarkStyle:=VMarkStyle;
		Case MarkStyle Of
			bmMenuDown: PicMark:=PicBtnArDown;
			bmMenuUp: PicMark:=PicBtnArUp;
			bmSwitch: PicMark:=PicBtnArRight;
			bmDialog: PicMark:=PicBtnDlg;
		End
	End;
	Button_TryAutoRedraw(Me)
End;

Procedure Button_SetOwnerCtl(Me,VOwnerCtl:PControl);
Begin
	With Me^, TButton(Data^) Do
		OwnerCtl:=VOwnerCtl
End;
{ ᮧ  }
Function Button_Create(Prog:PProg; VCaption:String; VPicture:Pointer;
	VPicturePos:TPicturePos; VOnPress:TCtlHandler): PControl;
Var
	Me:PControl;
Begin
	Me:=Kernel.AddCtl(Prog);
		{Button_OnClick, Button_OnKey, Kernel.CtlRefocusDummy,
		Kernel.CtlDummy, Button_OnDestroy, VEnabled, False, Hint);}
	With Me^ Do
	Begin
		OnClick:=Button_OnClick;
		OnKey:=Button_OnKey;
		OnDestroy:=Button_OnDestroy;

		GetMem(Data, SizeOf(TButton));
		With TButton(Data^) Do
		Begin
			D.AssignPStr(VCaption, Caption);
			OnPress:=VOnPress;
			Picture:=VPicture;
			PicturePos:=VPicturePos;
			Down:=False;
			DownNow:=False;
			MarkStyle:=bmNone;
			OwnerCtl:=Nil;
		End
	End;
	Button_Create:=Me
End;
