{$F+}
Unit
	AboutApp; { Polit Halcyon about box }

Interface

Uses
	Kernel, Types, D, Gfx, Ctl;

Type
	TAboutAppData=Record
		PicLogo: Pointer;
		PctLogo: PControl;
		Lab: Array[1..8] Of PControl;
		BtnClose: PControl;
	End;

Implementation

Procedure AboutApp_OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TAboutAppData(Data^) Do
	Begin
		Ctl.PicCtl_Paint(PctLogo, 5, 21);
		Ctl.Button_Paint(BtnClose, X2-X1-90, Y2-Y1-30, X2-X1-9);

		Ctl.Label_Paint(Lab[1], 190, 15, X2-X1);
		Ctl.Label_Paint(Lab[2], 190, 30, X2-X1);

		Ctl.Label_Paint(Lab[3], 190, 55, X2-X1);
		Ctl.Label_Paint(Lab[4], 190, 70, X2-X1);
		Ctl.Label_Paint(Lab[5], 190, 85, X2-X1);

		Ctl.Label_Paint(Lab[6], 190, 110, X2-X1);
		Ctl.Label_Paint(Lab[7], 190, 125, X2-X1);
		Ctl.Label_Paint(Lab[8], 190, 140, X2-X1);
	End
End;

Procedure AboutApp_OnClose(Me:PProg);
Begin
	{With TAboutAppData(Me^.Data^) Do
		Gfx.FreeImage(PicLogo);}
	Kernel.FreeRes('biglogo.bmp');
	FreeMem(Me^.Data, SizeOf(TAboutAppData))
End;

Procedure AboutApp_CloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.CloseProg(Me)
End;

Procedure AboutApp_OnInit(Me:PProg);
Begin
	With Me^ Do
	Begin
		D.AssignPStr('i: About', WinTitle);
		MinX:=450;
		MinY:=210;
		OnPaint:=AboutApp_OnPaint;
		OnClose:=AboutApp_OnClose;
		GetMem(Data,SizeOf(TAboutAppData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindowAni(Me);

		With TAboutAppData(Data^) Do
		Begin
			PicLogo:=Kernel.LoadBMPRes('pic\biglogo.bmp');
			PctLogo:=Ctl.PicCtl_Create(Me, PicLogo, False, False, True);

			Lab[1]:=Ctl.Label_Create(Me, ' DOS "i"', Nil, lsNormal, alCenter);
			Lab[2]:=Ctl.Label_Create(Me, 'i筠  i 5 ௭ ப 2004', Nil, lsNormal, alCenter);

			Lab[3]:=Ctl.Label_Create(Me, 'Copyright (C) 1999-2004', Nil, lsNormal, alCenter);
			Lab[4]:=Ctl.Label_Create(Me, 'I  (iv_kozak@ukr.net)  ii', Nil, lsNormal, alCenter);
			Lab[5]:=Ctl.Label_Create(Me, 'Web-ᠩ: http://polit-os.org.ua/', Nil, lsNormal, alCenter);

			Lab[6]:=Ctl.Label_Create(Me, 'i - i쭥 ணࠬ 祭', Nil, lsNormal, alCenter);
			Lab[7]:=Ctl.Label_Create(Me, 'i ஧  㬮', Nil, lsNormal, alCenter);
			Lab[8]:=Ctl.Label_Create(Me, 'i業i GNU GPL (. 䠩 GPL_UKR.TXT)', Nil, lsNormal, alCenter);

			BtnClose:=Ctl.Button_Create(Me, '', Kernel.PicClose,
				ppLeft, AboutApp_CloseClick);
			ButtonEnter:=BtnClose;
			ButtonEsc:=BtnClose
		End
	End;
End;


Begin
	Kernel.RegBuiltIn('AboutApp', ' i', 'pic\i_polit.bmp', AboutApp_OnInit)
End.