{$F+}
Unit
	AppWiz; { Polit Halcyon third test application }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx;

Type
	TAppWizData=Record
		NbkMain: PControl;

		Lab1, Lab2, Lab3, Lab4, Lab5, Lab6, Lab7: PControl;
		InpFName, InpWinTitle, InpIcon,
		InpMinX, InpMinY, InpWinLook, InpUnits: PControl;
		ChkComments: PControl;

		ChkOnInit, ChkOnClose, ChkOnPaint, ChkOnIdle,
		ChkOnMessage, ChkOnKey: PControl;

		PicGo, PicWatermark: Pointer;
		BtnGo, BtnClose: PControl;
		PctWatermark1: PControl;
	End;

Implementation

Procedure AppWiz_OnPaint(Me:PProg);
Var
	I, Temp: Integer;
Begin
	With Me^, ClientRect, TAppWizData(Data^) Do
	Begin
		Kernel.DarkBar(X1, Y1, X2, Y1+4);
		Kernel.DarkBar(X1, Y1+5, X1+4, Y2-35);
		Kernel.DarkBar(X2-4, Y1+5, X2, Y2-35);
		Kernel.DarkBar(X1, Y2-34, X2, Y2);

		Ctl.Notebook_Paint(NbkMain, 5, 5, X2-X1-5, Y2-Y1-35);

			{ Page 1 - common }
		Ctl.PicCtl_Paint(PctWatermark1, 15, 35);

		Ctl.Label_Paint(Lab1, 15, 40, 150);
		Ctl.InpLine_Paint(InpFName, 160, 40, X2-X1-15);

		Ctl.Label_Paint(Lab2, 15, 70, 150);
		Ctl.InpLine_Paint(InpWinTitle, 160, 70, X2-X1-15);

		Ctl.Label_Paint(Lab3, 15, 100, 150);
		Ctl.InpLine_Paint(InpIcon, 160, 100, X2-X1-15);

		Ctl.Label_Paint(Lab4, 15, 130, 150);
		Ctl.InpLine_Paint(InpMinX, 160, 130, 205);

		Ctl.Label_Paint(Lab5, 210, 130, 230);
		Ctl.InpLine_Paint(InpMinY, 235, 130, 285);

		Ctl.Label_Paint(Lab6, 15, 160, 150);
		Ctl.InpLine_Paint(InpWinLook, 160, 160, X2-X1-15);

		Ctl.Label_Paint(Lab7, 15, 190, 150);
		Ctl.InpLine_Paint(InpUnits, 160, 190, X2-X1-15);

		Ctl.Check_Paint(ChkComments, 160, 230);

			{ page 2 - handlers }
		Ctl.Check_Paint(ChkOnInit, 15, 40);
		Ctl.Check_Paint(ChkOnPaint, 15, 60);
		Ctl.Check_Paint(ChkOnIdle, 15, 80);
		Ctl.Check_Paint(ChkOnMessage, 15, 100);
		Ctl.Check_Paint(ChkOnKey, 15, 120);
		Ctl.Check_Paint(ChkOnClose, 15, 140);

			{ outside of notebook }
		Ctl.Button_Paint(BtnGo, X2-X1-210, Y2-Y1-26, X2-X1-80);
		Ctl.Button_Paint(BtnClose, X2-X1-70, Y2-Y1-26, X2-X1-5);

	End
End;

Procedure AppWiz_OnClose(Me:PProg);
Begin
	Kernel.FreeRes('b_go.bmp');
	Kernel.FreeRes('w_appwiz.bmp');
	FreeMem(Me^.Data, SizeOf(TAppWizData))
End;

Procedure AppWiz_OnGoClick(Me:PProg; Control:PControl);
Var
	F: Text;
	Temp, Temp2: String;
	Rems: Boolean;
Begin
	With Me^, TAppWizData(Data^) Do
	Begin
		Rems:=Ctl.Check_GetState(ChkComments);
		Temp:=Ctl.InpLine_GetText(InpFName);
		If Pos('.', Temp)=0 Then
			Temp:=Temp+'.pas';
		Assign(F, Temp);
		Rewrite(F);
		WriteLn(F, '{$F+}');
		WriteLn(F, 'Unit');
		Temp:=Copy(Temp, 1, Pos('.',Temp)-1);
		WriteLn(F, #9+Temp+'; { Polit Halcyon '+Temp+' application }');
		WriteLn(F);
		WriteLn(F, 'Interface');
		WriteLn(F);
		WriteLn(F, 'Uses');
		WriteLn(F, #9'Kernel, Types, D, Ctl, Ctl2, Popup;');
		WriteLn(F);
		WriteLn(F, 'Type');
		WriteLn(F, #9'T'+Temp+'Data=Record');
		If Rems Then
			WriteLn(F, #9#9'{ i i ணࠬ  ,  쮬 i }');
		WriteLn(F);
		WriteLn(F, #9'End;');
		WriteLn(F);
		WriteLn(F, 'Implementation');
		WriteLn(F);

		If Ctl.Check_GetState(ChkOnPaint) Then
		Begin
			WriteLn(F, 'Procedure OnPaint(Me:PProg);');
			WriteLn(F, 'Begin');
			WriteLn(F, #9'With Me^, ClientRect, T'+Temp+'Data(Data^) Do');
			WriteLn(F, #9'Begin');
			If Rems Then
			Begin
				WriteLn(F, #9#9'{ i   i i                         }');
				WriteLn(F, #9#9'{ 砩 ⮡i ॡ   i  㢠 }')
			End;
			WriteLn(F);
			WriteLn(F, #9'End;');
			WriteLn(F, 'End;');
			WriteLn(F)
		End;

		If Ctl.Check_GetState(ChkOnIdle) Then
		Begin
			WriteLn(F, 'Procedure OnIdle(Me:PProg);');
			WriteLn(F, 'Begin');
			WriteLn(F, #9'With Me^, T'+Temp+'Data(Data^) Do');
			WriteLn(F, #9'Begin');
			If Rems Then
			Begin
				WriteLn(F, #9#9'{ i  i筮,  i  ⨩ i稬 i訬          }');
				WriteLn(F, #9#9'{   㭮 ஡ ⮧i (ࠫ쭠 ஡ ணࠬ)   }');
				WriteLn(F, #9#9'{  ⢮ ணࠬ   ஡ i, " 䮭i" -    }');
				WriteLn(F, #9#9'{ ० -   楤  i쮢㢠 类 袨   }');
			End;
			WriteLn(F);
			WriteLn(F, #9'End');
			WriteLn(F, 'End;');
			WriteLn(F)
		End;

		If Ctl.Check_GetState(ChkOnMessage) Then
		Begin
			WriteLn(F, 'Function OnMessage(Me, Sender:PProg; Msg:String; Data:Pointer): Pointer;');
			WriteLn(F, 'Begin');
			WriteLn(F, #9'With Me^, T'+Temp+'Data(Data^) Do');
			WriteLn(F, #9'Begin');
			If Rems Then
			Begin
				WriteLn(F, #9#9'{ i ,  i  ணࠬ (Sender) }');
				WriteLn(F, #9#9'{ ᨫ i i ணࠬi. Msg - ᭥   }');
				WriteLn(F, #9#9'{ ⥪ i, Data^ - ࠬ ( ॡ). }');
				WriteLn(F, #9#9'{  ॡ,   (Pointer ) १. }')
			End;
			WriteLn(F);
			WriteLn(F, #9#9'OnMessage:=Nil');
			WriteLn(F, #9'End');
			WriteLn(F, 'End;');
			WriteLn(F)
		End;

		If Ctl.Check_GetState(ChkOnKey) Then
		Begin
			WriteLn(F, 'Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;');
			WriteLn(F, 'Begin');
			WriteLn(F, #9'With Me^, T'+Temp+'Data(Data^) Do');
			WriteLn(F, #9'Begin');
			If Rems Then
			Begin
				WriteLn(F, #9#9'{ i   ᭥i -类 ii  ii. }');
				WriteLn(F, #9#9'{  筮  ணࠬ㢠  i,  ⠪ i.     }');
				WriteLn(F, #9#9'{  i 㫠 ஡, ୨ True, i - False     }');
				WriteLn(F, #9#9'{ (i ⮤i i 㤥 । ࠭  㢠)   }')
			End;
			WriteLn(F);
			WriteLn(F, #9'End;');
			WriteLn(F, #9'OnKey:=False');
			WriteLn(F, 'End;');
			WriteLn(F)
		End;

		If Ctl.Check_GetState(ChkOnClose) Then
		Begin
			WriteLn(F, 'Procedure OnClose(Me:PProg);');
			WriteLn(F, 'Begin');
			If Rems Then
			Begin
				WriteLn(F, #9'{ i   i i }');
				WriteLn(F, #9'{   OnInit   '' (GetMem, New)  ⠦ }');
				WriteLn(F, #9'{  (Kernel.LoadRes),   ॡ  i      }')
			End;
			WriteLn(F, #9'FreeMem(Me^.Data, SizeOf(T'+Temp+'Data))');
			WriteLn(F, 'End;');
			WriteLn(F)
		End;

		WriteLn(F, 'Procedure OnInit(Me:PProg);');
		WriteLn(F, 'Begin');
		If Rems Then
			WriteLn(F, #9'{ i    ணࠬ }');
		If Ctl.Check_GetState(ChkOnPaint) Then
			WriteLn(F, #9'Me^.OnPaint:=OnPaint;');
		If Ctl.Check_GetState(ChkOnIdle) Then
			WriteLn(F, #9'Me^.OnIdle:=OnIdle;');
		If Ctl.Check_GetState(ChkOnMessage) Then
			WriteLn(F, #9'Me^.OnMessage:=OnMessage;');
		If Ctl.Check_GetState(ChkOnKey) Then
			WriteLn(F, #9'Me^.OnKey:=OnKey;');
		If Ctl.Check_GetState(ChkOnClose) Then
			WriteLn(F, #9'Me^.OnClose:=OnClose;');
		WriteLn(F, #9'With Me^ Do');
		WriteLn(F, #9'Begin');
		Write(F, #9#9'D.AssignPStr(''');
		WriteLn(F, Ctl.InpLine_GetText(InpWinTitle)+''', WinTitle);');
		WriteLn(F, #9#9'MinX:='+Ctl.InpLine_GetText(InpMinX)+';');
		WriteLn(F, #9#9'MinY:='+Ctl.InpLine_GetText(InpMinY)+';');
		WriteLn(F, #9#9'GetMem(Data, SizeOf(T'+Temp+'Data));');
		Write(F, #9#9'Kernel.InitWindow(Me, ''');
		Temp2:=Ctl.InpLine_GetText(InpWinLook);
		If Temp2='BlueWin'
			Then WriteLn(F, Temp2+''', [wbMin, wbMax, wbClose]);')
			Else WriteLn(F, Temp2+''', [wbHelp, wbClose]);');
		WriteLn(F, #9#9'Kernel.DrawWindowAni(Me);');
		WriteLn(F);
		WriteLn(F, #9#9'With T'+Temp+'Data(Data^) Do');
		WriteLn(F, #9#9'Begin');
		If Rems Then
			WriteLn(F, #9#9#9'{  -  i  ⢮७ i i 㢠 }');
		WriteLn(F);
		WriteLn(F, #9#9'End');
		WriteLn(F, #9'End');
		WriteLn(F, 'End;');
		WriteLn(F);
		WriteLn(F);
		WriteLn(F);

		WriteLn(F, 'Begin');
		Write(F, #9'Kernel.RegBuiltIn('''+Temp+''', '''+Temp+''', ''');
		WriteLn(F, Ctl.InpLine_GetText(InpIcon)+''', OnInit)');
		WriteLn(F, 'End.');

		Close(F);

		Kernel.ShowHint('⮢ ii쪮 ணࠬ ஡.'+#13+
			' 䠩 '+Temp+'.Pas')
	End
End;

Procedure AppWiz_OnCloseClick(Me:PProg; Control:PControl);
Begin
	Kernel.FreeRes('b_go.bmp');
	Kernel.FreeRes('b_cancel.bmp');
	Kernel.FreeRes('w_appwiz.bmp');
	Kernel.CloseProg(Me)
End;

Procedure AppWiz_OnInit(Me:PProg);
Begin
	With Me^ Do
	Begin
		D.AssignPStr('App Wizard '+String(Param^), WinTitle);
		MinX:=300;
		MinY:=300;
		OnPaint:=AppWiz_OnPaint;
		OnClose:=AppWiz_OnClose;
		GetMem(Data,SizeOf(TAppWizData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindow(Me);

		With TAppWizData(Data^) Do
		Begin
			PicGo:=Kernel.LoadBMPRes('pic\b_go.bmp');
			PicWatermark:=Kernel.LoadBMPRes('pic\w_appwiz.bmp');

			NbkMain:=Ctl.Notebook_Create(Me, True);
			PctWatermark1:=Ctl.PicCtl_Create(Me, PicWatermark, False, True, True);

			Lab1:=Ctl.Label_Create(Me, 'I'' 䠩:', Nil, lsNormal, alRight);
			Lab2:=Ctl.Label_Create(Me, ' i:', Nil, lsNormal, alRight);
			Lab3:=Ctl.Label_Create(Me, ' i (BMP):', Nil, lsNormal, alRight);
			Lab4:=Ctl.Label_Create(Me, 'i. ஧i i:', Nil, lsNormal, alRight);
			Lab5:=Ctl.Label_Create(Me, 'x', Nil, lsNormal, alCenter);
			Lab6:=Ctl.Label_Create(Me, ' i (WinLook):', Nil, lsNormal, alRight);
			Lab7:=Ctl.Label_Create(Me, '⪮i i:', Nil, lsNormal, alRight);

			InpFName:=Ctl.InpLine_Create(Me, 'TestApp', Nil);
			InpWinTitle:=Ctl.InpLine_Create(Me, '⮢ ணࠬ', Nil);
			InpIcon:=Ctl.InpLine_Create(Me, 'pic\i_app.bmp', Nil);
			InpMinX:=Ctl.InpLine_Create(Me, '350', Nil);
			InpMinY:=Ctl.InpLine_Create(Me, '240', Nil);
			InpWinLook:=Ctl.InpLine_Create(Me, 'BlueWin', Nil);
			InpUnits:=Ctl.InpLine_Create(Me, '', Nil);

			Lab1^.FocusCtl:=InpFName;
			Lab2^.FocusCtl:=InpWinTitle;
			Lab3^.FocusCtl:=InpIcon;
			Lab4^.FocusCtl:=InpMinX;
			Lab5^.FocusCtl:=InpMinY;
			Lab6^.FocusCtl:=InpWinLook;
			Lab7^.FocusCtl:=InpUnits;

			ChkComments:=Ctl.Check_Create(Me, '⠢ i', True);

			Ctl.Notebook_AddPage(NbkMain, '쭥',
				' i, i, ஧i,'#13' i, ⪮i i', Nil);

			{CanWatermark2:=Ctl.Canvas_Create(Me,'');}
			ChkOnInit:=Ctl.Check_Create(Me, 'OnInit -  ணࠬ', True);
			ChkOnInit^.Enabled:=False;
			ChkOnPaint:=Ctl.Check_Create(Me, 'OnPaint -  i', True);
			ChkOnIdle:=Ctl.Check_Create(Me, 'OnIdle -  i', False);
			ChkOnMessage:=Ctl.Check_Create(Me, 'OnMessage - i', False);
			ChkOnKey:=Ctl.Check_Create(Me, 'OnKey - ᭥ ii', False);
			ChkOnClose:=Ctl.Check_Create(Me, 'OnClose -  ணࠬ', True);
			ChkOnClose^.Enabled:=False;

			Ctl.Notebook_AddPage(NbkMain, '஡','', Nil);

			BtnGo:=Button_Create(Me, '஡ ⮢', PicGo,
				ppLeft, AppWiz_OnGoClick);
			BtnClose:=Button_Create(Me, '', Kernel.PicClose,
				ppLeft, AppWiz_OnCloseClick);
			ButtonEnter:=BtnGo;
			ButtonEsc:=BtnClose;

			ActiveCtl:=InpFName
		End
	End
End;


Begin
	Kernel.RegBuiltIn('AppWiz', ' ணࠬ', 'pic\i_appwiz.bmp', AppWiz_OnInit)
End.