{$F+}
Unit
	calc; { Polit Halcyon Calc application by m.t. (masterdron)  }

Interface

Uses
	Kernel, Types, D, Ctl, Gfx{, Strings};

Type
	Extended=Real;

	TcalcData=Record
		{ i i ணࠬ  ,  쮬 i }
					 Lab_Ind : PControl;
                btn_0, btn_1, btn_2, btn_3,btn_4,btn_5,btn_6,btn_7,btn_8,btn_9,
                btn_plus,btn_minus,btn_mult,btn_div,btn_res,btn_point,btn_clear : PControl;

					 new_op : boolean;
					 operator : string;
					 op_1, op_2 : extended;

	End;

Implementation

Function StrToExtended(S:String):Extended;
Var
	Temp:Extended;
	Res:Word;
Begin
	Val(S, Temp, Res);
	If Res=0
		Then StrToExtended:=Temp
		Else StrToExtended:=0
End;

Function ExtToStr(R:Extended): String;
Var
	S: String;
	N: Byte;
Begin
	Str(R:21:10, S);
	While S[1]=' ' Do
		S:=Copy(S, 2, Length(S)-1);
	While S[Byte(S[0])]='0' Do
		Dec(Byte(S[0]));
	If S[Byte(S[0])]='.' Then
		Dec(Byte(S[0]));
	ExtToStr:=S
End;



{*********************************************************************************}
Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TcalcData(Data^) Do
	Begin
		Ctl.Label_Paint(Lab_Ind, 10, 10, X2-X1-10);

                Ctl.Button_Paint(btn_clear, 12, 40, 65);
                Ctl.Button_Paint(btn_7, 12, 67, 35);
                Ctl.Button_Paint(btn_4, 12, 97, 35);
                Ctl.Button_Paint(btn_1, 12, 127, 35);
                Ctl.Button_Paint(btn_point, 12, 157, 35);

                Ctl.Button_Paint(btn_8, 42, 67, 65);
                Ctl.Button_Paint(btn_5, 42, 97, 65);
                Ctl.Button_Paint(btn_2, 42, 127, 65);
                Ctl.Button_Paint(btn_0, 42, 157, 65);

                Ctl.Button_Paint(btn_9, 72, 67, 95);
                Ctl.Button_Paint(btn_6, 72, 97, 95);
                Ctl.Button_Paint(btn_3, 72, 127, 95);
                Ctl.Button_Paint(btn_res, 72, 157, 95);

                Ctl.Button_Paint(btn_plus, 102, 67, 125);
                Ctl.Button_Paint(btn_minus, 102, 97, 125);
                Ctl.Button_Paint(btn_mult, 102, 127, 125);
                Ctl.Button_Paint(btn_div, 102, 157, 125);
	End;
	Log.BugMsg('Calc', 'OnPaint', 'Finished')
End;

{*********************************************************************************}
Procedure OnNumClick(Me:PProg;Control:PControl);
var num : string;
    digit, bs : string;
    i : integer;
begin
	  With Me^, TcalcData(Data^) do
	  begin
			 digit:=Ctl.Button_GetCaption(Control);
			 num:=digit[2];

			 bs := ctl.Label_getCaption(Lab_Ind);

          if new_op then begin bs:='0'; new_op:=false; end;

          if num='.' then
             for i:=1 to length(bs) do
                 if bs[i]='.' then num:='';

          if (bs='0') and (num>'') and (num<>'.') then bs:='';
			 ctl.Label_SetCaption(Lab_Ind, bs+num);

	  end;
end;
{*********************************************************************************}
Procedure OnResClick(Me:PProg;Control:PControl);
begin
With Me^, TcalcData(Data^) do
begin
	  if operator='' then exit;
	  op_2:=strtoExtended(ctl.Label_getCaption(Lab_Ind));

     new_op:=true;

	  case operator[1] of
	  '+' : ctl.Label_SetCaption(Lab_ind, ExtToStr(op_1+op_2));
	  '-' : ctl.Label_SetCaption(Lab_Ind, ExtToStr(op_1-op_2));
	  '*' : ctl.Label_SetCaption(Lab_Ind, ExtToStr(op_1*op_2));
     '/' : begin
					 if op_2<> 0
							 then ctl.Label_SetCaption(Lab_Ind, ExtToStr(op_1/op_2))
							 else ctl.Label_SetCaption(Lab_ind, 'Error');
           end;
	  end;
	  operator:=''
end;
end;

{*********************************************************************************}
Procedure OnOpClick(Me:PProg;Control:PControl);
var digit : string;
	 i : integer;
begin
With Me^, TcalcData(Data^) do
begin
	  if operator<>'' then
		  OnResClick(Me, Btn_Res);
	  op_1:=strtoExtended(ctl.Label_getCaption(Lab_Ind));

	  digit:=Ctl.Button_GetCaption(Control);
	  operator:=digit[2];

	  new_op:=true;

	  {log.msg('calc','operator',operator);}
end;
end;
{*********************************************************************************}
Procedure OnClearClick(Me:PProg;Control:PControl);
begin
With Me^, TcalcData(Data^) do
begin
	  op_1:=0;
	  op_2:=0;

	  new_op:=false;

	  ctl.Label_SetCaption(Lab_Ind, '0');

     operator:='';
end;
end;
{*********************************************************************************}
Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TcalcData));
End;
{* by iv kozak ********************************************************************************}
Function OnKey(Me:PProg; Key,ExtKey:Char): Boolean;
Var
	Recognized:Boolean;

	Procedure ClickButton(VBtn:PControl);
	Begin
		Kernel.ClickCtl(Me, VBtn);
		Recognized:=True
	End;
Begin
	Recognized:=False;
	With Me^, TcalcData(Data^) do
		Case Key Of
			'0': ClickButton(Btn_0);
			'1': ClickButton(Btn_1);
			'2': ClickButton(Btn_2);
			'3': ClickButton(Btn_3);
			'4': ClickButton(Btn_4);
			'5': ClickButton(Btn_5);
			'6': ClickButton(Btn_6);
			'7': ClickButton(Btn_7);
			'8': ClickButton(Btn_8);
			'9': ClickButton(Btn_9);

			'+': ClickButton(Btn_Plus);
			'-': ClickButton(Btn_Minus);
			'*': ClickButton(Btn_Mult);
			'/': ClickButton(Btn_Div);

			'=': ClickButton(Btn_Res);
			'.': ClickButton(Btn_Point);
			'c', 'C': ClickButton(Btn_Clear);
		End;
	OnKey:=Recognized
End;
{*********************************************************************************}
Procedure OnInit(Me:PProg);
Begin

	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	Me^.OnKey:=OnKey;
	With Me^ Do
	Begin
		D.AssignPStr('Calculator', WinTitle);
		MinX:=140;
		MinY:=190;
		GetMem(Data, SizeOf(TcalcData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindowAni(Me);

		With TcalcData(Data^) Do
		Begin
								{inp_ln:=Ctl.InpLine_Create(Me,'0',True,'');}
								Lab_Ind:=Ctl.Label_Create(Me, '0', Nil, lsBeveled, alRight);
								btn_0:=Ctl.Button_Create(Me, ' 0', nil, ppLeft, OnNumClick);
								btn_1:=Ctl.Button_Create(Me, ' 1', nil, ppLeft, OnNumClick);
								btn_2:=Ctl.Button_Create(Me, ' 2', nil, ppLeft, OnNumClick);
								btn_3:=Ctl.Button_Create(Me, ' 3', nil, ppLeft, OnNumClick);
								btn_4:=Ctl.Button_Create(Me, ' 4', nil, ppLeft, OnNumClick);
								btn_5:=Ctl.Button_Create(Me, ' 5', nil, ppLeft, OnNumClick);
								btn_6:=Ctl.Button_Create(Me, ' 6', nil, ppLeft, OnNumClick);
								btn_7:=Ctl.Button_Create(Me, ' 7', nil, ppLeft, OnNumClick);
								btn_8:=Ctl.Button_Create(Me, ' 8', nil, ppLeft, OnNumClick);
								btn_9:=Ctl.Button_Create(Me, ' 9', nil, ppLeft, OnNumClick);
								btn_plus:=Ctl.Button_Create(Me, ' +', nil, ppLeft, OnOpClick);
								btn_minus:=Ctl.Button_Create(Me, ' -', nil, ppLeft, OnOpClick);
								btn_mult:=Ctl.Button_Create(Me, ' *', nil, ppLeft, OnOpClick);
								btn_div:=Ctl.Button_Create(Me, ' /', nil, ppLeft, OnOpClick);
								btn_point:=Ctl.Button_Create(Me, ' .', nil, ppLeft, OnNumClick);
								btn_res:=Ctl.Button_Create(Me, ' =', nil, ppLeft, OnResClick);
								btn_clear:=Ctl.Button_Create(Me, ' C', nil, ppLeft, OnClearClick);

								new_op:=false;
								ButtonEnter:=Btn_Res;
								ButtonEsc:=Btn_Clear;
								ActiveCtl:=Nil
		End;
	End
End;
{*********************************************************************************}
Begin
	Kernel.RegBuiltIn('Calc', '', 'pic\i_calc.bmp', OnInit)
End.
