{ ******* DRAWING PAGE ******* }

Procedure DrawPage(Me:PControl);
Var
	CurItem: PPageItem;
	FontIndex: Integer;
	LastFont: Pointer;
Begin
	{With Area[1] Do
	Begin
		Gfx.Rectangle(X1-1, Y1-1, X2+1, Y2+1, DocProps.LinkColor);
		Gfx.Bar(X1, Y1, X2, Y2, DocProps.BGColor)
	End;}

	LastFont:=Font.GetFont;
	Font.SetFont(MyFont);
	CurItem:=FirstPageItem;
	While CurItem<>Nil Do
	Begin
		If D.RectInRectCoord(CurItem^.Place, 3, HTMLFirstY+3,
			Me^.Place.X2-Me^.Place.X1-2, HTMLFirstY+Me^.Place.Y2-Me^.Place.Y1-2) Then
			With CurItem^, Place Do
				Case Kind Of
					piText: Begin
						{Graph.SetColor(7);
						Graph.Rectangle(X1, Y1, X2, Y2);}
						Log.BugMsg('HTML', 'DrawPage:Text', '"'+String(Text^)+'"');
						Log.ActMsg('X = '+D.St(X1)+', Y = '+D.St(Y1));
						{Gfx.Rectangle(X1, Y1,
							X1+VFont.Width(String(Text^), FSize[Attr.Size]),
							Y1+VFont.Height(VFont.Fnt, FSize[Attr.Size]), 7);}
						Font.PrintVector(Me^.Place.X1+X1, -HTMLFirstY+Me^.Place.Y1+Y1,
							Attr.Color, FSize[Attr.Size], Attr.Attr, String(Text^));
					End;
					piRect: Begin
						Log.BugMsg('HTML', 'DrawPage:Rect', '');
						Log.ActMsg('X1 = '+D.St(X1)+', Y1 = '+D.St(Y1)+
							', X2 = '+D.St(X2)+', Y2 = '+D.St(Y2));
						Gfx.Rectangle(Me^.Place.X1+X1, -HTMLFirstY+Me^.Place.Y1+Y1,
							Me^.Place.X1+X2, -HTMLFirstY+Me^.Place.Y1+Y2, Color1)
					End;
					piBar: Begin
						Log.BugMsg('HTML', 'DrawPage:Bar', '');
						Log.ActMsg('X1 = '+D.St(X1)+', Y1 = '+D.St(Y1)+
							', X2 = '+D.St(X2)+', Y2 = '+D.St(Y2));
						Gfx.Bar(Me^.Place.X1+X1, -HTMLFirstY+Me^.Place.Y1+Y1,
							Me^.Place.X1+X2, -HTMLFirstY+Me^.Place.Y1+Y2, Color1)
					End;
					piImage: Begin
						{Gfx.RectAngle(X1, Y1, X2, Y2, 0);
						Gfx.RectAngle(X1+1, Y1+1, X2-1, Y2-1, 15);
						Gfx.RectAngle(X1+2, Y1+2, X2-2, Y2-2, 0);
						Gfx.RectAngle(X1+3, Y1+3, X2-3, Y2-3, 15);}
						Gfx.PutBigSprite(Me^.Place.X1+X1,
							-HTMLFirstY+Me^.Place.Y1+Y1, Image);
					End;

				End;
		CurItem:=CurItem^.Next
	End;
	Font.SetFont(LastFont)
End;
