{$F+}
Unit
	Info; { Polit Halcyon InfoMsg application by Vanyok}

Interface

Uses
	Kernel, Types, D, Ctl;

Type
	TInfoData=Record
		PctApp, LabInfo, BtnOK: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TInfoData(Data^) Do
	Begin
		Ctl.PicCtl_Paint(PctApp, 10, 10);
		Ctl.Label_Paint(LabInfo, 40, 10, X2-X1-10);
		Ctl.Button_Paint(BtnOk, 40, Y2-Y1-30, 140);
  End;
End;

Procedure OnOkClick(Me:PProg; Control:PControl);
Begin
  Kernel.CloseProg(Me)
End;


Procedure OnClose(Me:PProg);
Begin
  FreeMem(Me^.Data, SizeOf(TInfoData))
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr(' '+String(Parent^.Name^), WinTitle);
		MinX:=270;
		MinY:={210}20+D.CountChars(#13, String(Param^))*15+54;
		GetMem(Data, SizeOf(TInfoData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindow(Me);

		With Me^, TInfoData(Data^) Do
		Begin
			PctApp:=Ctl.PicCtl_Create(Me, Parent^.Icon, False, False, True);
			LabInfo:=Ctl.Label_Create(Me, String(Param^), Nil, lsBeveled, alLeft);
			BtnOk:=Ctl.Button_Create(Me, '', Kernel.PicClose, ppLeft, OnOkClick);
			ActiveCtl:=BtnOk;
			ButtonEnter:=BtnOk;
			ButtonEsc:=BtnOk
		End
	End
End;



Begin
  Kernel.RegBuiltIn('Info', '', '', OnInit)
End.
