{$F+}
Unit
	Rain; { Polit Halcyon Rain screensaver }

Interface

Uses
	Kernel, Gfx, Types;

Const
	SplashesNum=45;

Var
	Splash: Array[1..SplashesNum] Of Record
		X, Y, Radius: Integer;
		Color: TColor
	End;
	I: Integer;
	Count17: LongInt;
	CurN: Integer;


Implementation

Procedure InitSplash(Index:Integer);
Var
	Temp: Integer;
Begin
	With Splash[I] Do
	Begin
		{Temp:=Random(30);}
		Temp:=CurN;
		D.Cycle(CurN, 0, 29);
		Color:=Temp*2 Div 3;
		X:=Random(Gfx.ScrX-2*Color)+1;
		Y:=(Gfx.ScrY Div 2)+(Gfx.ScrY*Temp Div 60)-20+Random(40);
		D.ToRange(Y, Gfx.ScrY Div 2, Gfx.ScrY-Color);
		Radius:=2;
		Inc(Color, 228)
	End
End;

Procedure Rain_OnInit;
Begin
	Gfx.Bar(0,0,Gfx.ScrX,Gfx.ScrY,clBlack);
	For I:=1 To SplashesNum Do
		InitSplash(I);
	Count17:=0;
	CurN:=0;
End;

Procedure Rain_OnIdle;
Begin
	Inc(Count17);
	If Count17<D.MachineSpeed*2 Then Exit;
	Count17:=0;
	For I:=1 To SplashesNum Do
		With Splash[I] Do
		Begin
			Gfx.Ellipse(X, Y, Radius*2, Radius, clBlack);
			Dec(Color);
			Inc(Radius);
			If Color<=224
				Then InitSplash(I)
				Else Gfx.Ellipse(X, Y, Radius*2, Radius, Color)
		End
End;


Begin
	Kernel.RegScrSaver('Rain', Rain_OnInit, Rain_OnIdle)
End.