{$F+}
Unit
	Saver1; { Polit Halcyon first screensaver }

Interface

Uses
	Kernel, Gfx;

Const
	StarsNum=45;

Var
	Star:Array[1..StarsNum] Of Record
		X,Y:Integer;
		Color,Stadia:Integer
	End;
	I:Integer;
	Count17:LongInt;


Implementation

Procedure Black_OnInit;
Begin
	Gfx.Bar(0,0,Gfx.ScrX,Gfx.ScrY,clBlack);
	For I:=1 To StarsNum Do
		With Star[I] Do
		Begin
			X:=Random(Gfx.ScrX-2)+1;
			Y:=Random(Gfx.ScrY-2)+1;
			Color:=Random(5)+1;
			Stadia:=-Random(21)
		End;
	Count17:=0;
End;

Procedure Black_OnIdle;
Begin
	Inc(Count17);
	If Count17<D.MachineSpeed Then Exit;
	Count17:=0;
	For I:=1 To StarsNum Do
		With Star[I] Do
		Begin
			Inc(Stadia);
			Case Stadia Of
				0,8:PutPixel(X,Y,Color);
				1:PutPixel(X,Y,Color+8);
				2,6:Begin
					PutPixel(X-1,Y,Color);
					PutPixel(X+1,Y,Color);
					PutPixel(X,Y-1,Color);
					PutPixel(X,Y+1,Color)
				End;
				3:Begin
					PutPixel(X-1,Y,Color+8);
					PutPixel(X+1,Y,Color+8);
					PutPixel(X,Y-1,Color+8);
					PutPixel(X,Y+1,Color+8)
				End;
				4:Begin
					PutPixel(X-1,Y-1,Color);
					PutPixel(X+1,Y-1,Color);
					PutPixel(X-1,Y+1,Color);
					PutPixel(X+1,Y+1,Color)
				End;
				5:Begin
					PutPixel(X-1,Y-1,0);
					PutPixel(X+1,Y-1,0);
					PutPixel(X-1,Y+1,0);
					PutPixel(X+1,Y+1,0)
				End;
				7:Begin
					PutPixel(X-1,Y,0);
					PutPixel(X+1,Y,0);
					PutPixel(X,Y-1,0);
					PutPixel(X,Y+1,0)
				End;
				9:Begin
					PutPixel(X,Y,0);
					X:=Random(Gfx.ScrX-2)+1;
					Y:=Random(Gfx.ScrY-2)+1;
					Color:=Random(5)+1;
					Stadia:=-Random(21)
				End
			End
		End
End;


Begin
	Kernel.RegScrSaver('Black',Black_OnInit,Black_OnIdle)
End.