{$F+}
Unit
	TestInfo; { Polit Halcyon TestInfo application by Vanyok}

Interface

Uses
	Kernel, Types, D, Ctl, Popup;

Type
	TTestData=Record
		MyMenu: PMenuItem;
		Menu: PControl;
		Lab1: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestData(Data^) Do
	Begin
		Ctl.MainMenu_Paint(Menu, 5, 5, X2-X1-5);
		Ctl.Label_Paint(Lab1, 10, 30, X2-X1-5);
	End;
End;

Procedure OnExitClick(Me:PProg; Item:PMenuItem);
Begin
  Kernel.CloseProg(Me)
End;

Procedure OnAbtPolitClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TTestData(Data^) Do
		Kernel.RunChild2(Me, 'AboutApp', '')
End;

Procedure OnAbtAppClick(Me:PProg; Item:PMenuItem);
Begin
	With Me^, TTestData(Data^) Do
		Kernel.RunChild2(Me, 'Info', '  i Info'+#13+
			'i 0.1'+#13+#13+
			': '+#13+
			'vanyok@slavgorod.dp.ua')
End;

Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TTestData))
End;

Procedure MakeMenu(Me:PProg);
Var
	TempItem: PMenuItem;
Begin
	With Me^, TTestData(Data^) Do
	Begin
		MyMenu:=Popup.CreateMenu;
		TempItem:=Popup.AddSubmenu(MyMenu, '', '', Nil, True);
			Popup.AddCommand(TempItem, 'i', '', '', Nil, True, OnExitClick);

		TempItem:=Popup.AddSubmenu(MyMenu, 'i', '', Nil, True);
			Popup.AddCommand(TempItem, ' i', '', '', Nil, True, OnAbtPolitClick);
			Popup.AddSpace(TempItem);
			Popup.AddCommand(TempItem, ' ணࠬ', '', '', Nil, True, OnAbtAppClick);
	End
End;

Procedure OnInit(Me:PProg);
Begin
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('TestInfo', WinTitle);
		MinX:=300;
		MinY:=90;
		GetMem(Data, SizeOf(TTestData));
		Kernel.InitWindow(Me, 'BlueDlg', [wbClose]);
		Kernel.DrawWindow(Me);

		With TTestData(Data^) Do
		Begin
			MakeMenu(Me);
			Menu:=Ctl.MainMenu_Create(Me, MyMenu, ppLeft);

			Lab1:=Ctl.Label_Create(Me, ' i   ண'+#13+
				' i   㭪'+#13+
				'"i",  ⠬ " ணࠬ"', Nil, lsNormal, alCenter);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestInfo', ' AboutInfo', 'pic\i_app.bmp', OnInit)
End.
