{$F+}
Unit
	TestInp; { Polit Halcyon TestInp application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2;

Type
	TTestInpData=Record
		{ i i ணࠬ  ,  쮬 i }
		InpFName, InpContent, BtnWrite: PControl;
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestInpData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Ctl.InpLine_Paint(InpFName, 10, 10, X2-X1-10);
		Ctl.InpLine_Paint(InpContent, 10, 40, X2-X1-10);
		Ctl.Button_Paint(BtnWrite, X2-X1-100, Y2-Y1-30, X2-X1-10);
	End;
End;

Procedure OnWriteClick(Me:PProg; Control:PControl);
Var
	F: Text;
Begin
	With Me^, TTestInpData(Data^) Do
	Begin
		Assign(F, Ctl.InpLine_GetText(InpFName));
		Rewrite(F);
		Write(F, Ctl.InpLine_GetText(InpContent));
		Close(F);
		Kernel.ShowHint(' ᠭ')
	End
End;

Function OnFNameChange(Me:PProg; Control:PControl;
	Ch:String): String;
Begin
	If Ch[1] in [''..'', ''..'']
		Then OnFNameChange:=D.TranslitLine(Ch)
		Else OnFNameChange:=Ch
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestInpData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=240;
		MinY:=120;
		GetMem(Data, SizeOf(TTestInpData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestInpData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			InpFName:=Ctl.InpLine_Create(Me, 'file.txt', Nil);
			Ctl.InpLine_SetOnChangeFunc(InpFName, OnFNameChange);
			InpContent:=Ctl.InpLine_Create(Me, '(i쪠 i)', Nil);
			BtnWrite:=Ctl.Button_Create(Me, '', Nil, ppLeft,
			  OnWriteClick);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestInp', 'TestInp', 'pic\i_app.bmp', OnInit)
End.
