{$F+}
Unit
	TestPro; { Polit Halcyon TestPro application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2;

Type
	TTestProData=Record
		{ i i ணࠬ  ,  쮬 i }
		InpFName, InpChar: PControl;
		BtnStart: PControl;
		ProGress: PControl;
		LabResult: PControl;
		F: Text; { 䠩 }
		C: Char; { ᨬ, 直  㤥 㪠 }
		CurSize: LongInt; { 筠 ii ஡  }
		Occurences: Integer; { ii 室 ࠧ }
	End;

Implementation

Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TTestProData(Data^) Do
	Begin
		{ i   i i                         }
		{ 砩 ⮡i ॡ   i  㢠 }
		Ctl.InpLine_Paint(InpFName, 10, 10, X2-X1-10);
		Ctl.InpLine_Paint(InpChar, 10, 40, X2-X1-10);
		Ctl.Button_Paint(BtnStart, 10, 70, X2-X1-10);
		Ctl.Progress_Paint(ProGress, 10, 100, X2-X1-10);
		Ctl.Label_Paint(LabResult, 10, 130, X2-X1-10);
	End;
End;

Procedure OnIdle(Me:PProg);
Var
  S: String;
  V: Byte;
Begin
  With Me^, TTestProData(Data^) Do
  Begin
	 If Not EOF(F) Then
	 Begin { ஡ 筨 冷 }
		ReadLn(F, S);
		For V:=1 To Length(S) Do
		  If S[V]=C Then Inc(Occurences);
		Ctl.Label_SetCaption(LabResult, D.St(Occurences));
		Inc(CurSize, Length(S)+2);
		Ctl.Progress_SetValue(ProGress, Integer(CurSize))
	 End
	 Else Begin { i 䠩, i }
		Close(F);
		Me^.OnIdle:=Kernel.DummyProc
	 End
  End
End;

Procedure OnStartClick(Me:PProg; Control:PControl);
Var
	TempStr, FName: String;
	TempF: File;
Begin
	With Me^, TTestProData(Data^) Do
	Begin
		FName:=Ctl.InpLine_GetText(InpFName);
			{  i 䠩? }
		If Not D.FileExist(FName) Then
		Begin
			Log.BugMsg('TestPro', 'OnStartClick',
				'File not found: '+FName);
			Exit
		End;
		TempStr:=Ctl.InpLine_GetText(InpChar);
		If Length(TempStr)<>1 Then Exit;
		C:=TempStr[1];

		Assign(TempF, FName);
		Reset(TempF, 1);
		Ctl.Progress_SetParams(ProGress, 0, FileSize(TempF), 0);
		Close(TempF);

		Assign(F, FName);
		Reset(F);
		CurSize:=0;
		Occurences:=0
	End;
	Me^.OnIdle:=OnIdle
End;

Procedure OnClose(Me:PProg);
Begin
	{ i   i i }
	{   OnInit   ' (GetMem, New)  ⠦ }
	{  (Kernel.LoadRes),   ॡ  i      }
	FreeMem(Me^.Data, SizeOf(TTestProData))
End;

Procedure OnInit(Me:PProg);
Begin
	{ i    ணࠬ }
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	With Me^ Do
	Begin
		D.AssignPStr('⮢ ணࠬ', WinTitle);
		MinX:=240;
		MinY:=160;
		GetMem(Data, SizeOf(TTestProData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindowAni(Me);

		With TTestProData(Data^) Do
		Begin
			{  -  i  ⢮७ i i 㢠 }
			InpFName:=Ctl.InpLine_Create(Me, 'popup.pas', Nil);
			InpChar:=Ctl.InpLine_Create(Me, ';', Nil);
			BtnStart:=Ctl.Button_Create(Me, ' ',
			  Nil, ppLeft, OnStartClick);
			ProGress:=Ctl.Progress_Create(Me, 0, 10, 0, pkDeterm);
			LabResult:=Ctl.Label_Create(Me, '-', Nil, lsNormal, alCenter);
		End
	End
End;



Begin
	Kernel.RegBuiltIn('TestPro', 'TestPro', 'pic\i_app.bmp', OnInit)
End.
